# zipup.sh
#
# Script to generate the distribution zips from dos.
# This is not exactly the most portable or beautiful way of doing it, but it
# works on my machine.
#
# Requires pkzip, rm, sort, sed, tr, tolower (my own tool for converting dos
# filenames to lowercase), whisped (my own tool for converting tabs, newline
# characters and the like) and of course sh to execute the script.

echo clean up...
make clean
make rewhisp

echo generate dependencies...
./fixdll.bat
./fixming.bat
make depend
./fixmsvc.bat
make depend
./fixwat.bat
make depend
./fixunix.sh
make depend
./fixdjgpp.bat
make depend

echo generate other files for the distribution...
make readme.txt docs/readme.info docs/readme.html docs/readme.rtf "LFN=y"

echo whispedify everything
make rewhisp


echo remove old files...
rm -fv dime.zip dimetmp.zip

# Because of pkzip's brokenness, all directories that we specify on the
# command line will be saved as uppercase. So we copy all files that should
# be included in the zip to a temporary directory and then run pkzip -r *.*

# Find files and put them in temporary zip.
echo create temporary zip...
#files = */tmpfile.txt */*/tmpfile.txt */*/*/tmpfile.txt */*/*/*/tmpfile.txt \
#		  fix* makefile* obj/*/*/*.dep lib/*/*.def zipup.sh \
#		  readme.txt docs/*._tx docs/readme.html docs/readme.info docs/readme.rtf \
#		  src/*.c examples/example.c \
#		  include/dime.h include/dime/*.h
				
for file in */tmpfile.txt */*/tmpfile.txt */*/*/tmpfile.txt */*/*/*/tmpfile.txt \
				fix* makefile* obj/*/*/*.dep lib/*/*.def zipup.sh \
		  		readme.txt docs/*._tx docs/readme.html docs/readme.info docs/readme.rtf \
		  		src/*.c examples/example.c \
		  		include/dime.h include/dime/*.h; do
	pkzip -a -ex -P dimetmp.zip $file
done

# Unzip the temporary zip.
echo unzip temporary zip...
mkdir zipup.tmp
mkdir zipup.tmp/dime
cd zipup.tmp/dime
pkunzip -d ../../dimetmp.zip
rm -fv ../../dimetmp.zip

# Tolowerize files.
echo tolowerize files...
tolower -q -p +*

# Copy the default makefile to here.
echo copy temporary makefile to dimes directory...
cp ../../emptymak makefile
cd ..

# Create an archive with lowercase directories, appropriate makefile and
# everything in the dime/ directory.
echo finally, build the distribution zip!
pkzip -a -ex -P -r ../dime.zip *.*
cd ..
rm -fr zipup.tmp

echo generate html files for the homepage...
make docs

echo all done!
